// Copyright distributed.net 1997-1999 - All Rights Reserved
// For use in distributed.net projects only.
// Any other distribution or use of this source violates copyright.
//
// $Log: mac_client.h,v $
// Revision 1.2  1999/04/29 05:54:59  dicamillo
// Update for buffer file names and other common code changes.
//
// Revision 1.1  1999/04/08 06:18:41  dicamillo
// First Checked In.
//
// Revision 1.4  1999/01/07 03:19:31  dicamillo
// Add ReInitializeClient method.
//
// Revision 1.3  1999/01/01 02:45:15  cramer
// Part 1 of 1999 Copyright updates...
//
// Revision 1.2  1998/12/09 07:19:20  dicamillo
// Created
//

#if (CLIENT_OS == OS_MACOS)

class Mac_Client : public Client
{
unsigned long file_dates[4];

public:
	int InitializeClient(void);
	void ReInitializeClient(void);
	void ResetClient(void);
	void DeInitializeClient(void);
	double TimeCore(u32 numk, short core);
	s32 Startup( int argc, char *argv[] );
	void UpdateFileDates(void);
	unsigned long GetFileDate(const char *filename);
	Boolean ChangedFileDates(void);
	#if defined(MAC_GUI)
	  void RefreshBufferCounts(void);
	  void UpdateProblemStatus(unsigned int problem_count);
	#endif
};

#endif
