/* Copyright distributed.net 1997-1999 - All Rights Reserved			*/
/* For use in distributed.net projects only.							*/
/* Any other distribution or use of this source violates copyright.		*/
/*																		*/
/* $Log: general.r,v $
/* Revision 1.8.2.2  1999/07/11 00:29:08  sampo
/* simplify general config panel, add ability to set in and out buffers to different sizes.
/*
/* Revision 1.8.2.1  1999/05/18 03:27:44  sampo
/* large block support added to mac configuration
/*
/* Revision 1.8  1999/01/08 03:19:28  dicamillo
/* "Use MP Support" is off by default; issue warning on true MP machines.
/*
/* Revision 1.7  1999/01/07 03:18:19  dicamillo
/* Add error text for "OS too new" error.
/*
/* Revision 1.6  1999/01/01 06:37:57  vetere
/* Split about-box into about.r
/*
/* Revision 1.5  1998/12/31 03:17:25  dicamillo
/* Changed 'PICT' 128 to be in PICT format instead of data.
/*
/* Revision 1.4  1998/12/30 20:02:39  vetere
/* Added data for PICT #128: CowEarth for About Box
/*
/* Revision 1.3  1998/12/29 20:50:48  vetere
/* About box changes. :p
/*
/* Revision 1.2  1998/12/15 03:44:46  dicamillo
/* First checked in; fixed CVS log format.
/*																*/

#include "resdefs.h"
#define ALRT_RezTemplateVersion 0
#define DLOG_RezTemplateVersion 0
#define PICT_RezTemplateVersion 1
#include "Types.r"
#include "Dialogs.r"

#include "my_appearance.r"

resource 'FREF' (kAppFREFNum) {
	'APPL',
	0,
	""
};

resource 'FREF' (kPrefsFREFNum) {
	kPrefsSignature,
	1,
	""
};

resource 'BNDL' (kAppFREFNum) {
	kSignature,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 2 element3 */
			/* [1] */
			0, kAppFREFNum,
			/* [2] */
			1, kPrefsFREFNum,
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 2 element3 */
			/* [1] */
			0, kAppFREFNum,
			/* [2] */
			1, kPrefsFREFNum,
		}
	}
};

resource 'STR#' (kConfigResourceNum) {
	{
		/* [1]: Apple menu "About" item name: */
		"About The Client...",
		/* [2]: Program name for "About" dialog: */
		"Mac OS Client",
		/* [3]: Default console name: */
		"rc5des console log"
	}
};

resource 'MENU' (kAppleMenu, preload) {
	kAppleMenu,
	textMenuProc,
	allEnabled,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About The Client...", noIcon, "", "", plain,
		/* [2] */
		"Help...", noIcon, "", "", plain,
		/* [3] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (kFileMenu, preload) {
	kFileMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	{	/* array: 20 elements */	/* remember to update desc_tab in RC5App.cpp */
		/* [1] */
		"Show Log", noIcon, "L", "", plain,
		/* [2] */
		"Show Status", noIcon, "I", "", plain,
		/* [3] */
		"Close", noIcon, "W", "", plain,
		/* [4] */
		"-", noIcon, "", "", plain,
		/* [5] */
		"Run", noIcon, "R", "", plain,
		/* [6] */
		"Run Offline", noIcon, "", "", plain,
		/* [7] */
		"Run Buffers", noIcon, "", "", plain,
		/* [8] */
		"-", noIcon, "", "", plain,
		/* [9] */
		"Benchmark RC5", noIcon, "", "", plain,
		/* [10] */
		"Benchmark DES", noIcon, "", "", plain,
		/* [11] */
		"Test", noIcon, "", "", plain,
		/* [12] */
		"-", noIcon, "", "", plain,
		/* [13] */
		"Fetch", noIcon, "1", "", plain,
		/* [14] */
		"Flush", noIcon, "0", "", plain,
		/* [15] */
		"Update", noIcon, "U", "", plain,
		/* [16] */
		"-", noIcon, "", "", plain,
		/* [17] */
		"Quit Other Apps", noIcon, "", "", plain,
		/* [18] */
		"-", noIcon, "", "", plain,
		/* [19] */
		"Halt", noIcon, "H", "", plain,
		/* [20] */
		"Quit", noIcon, "Q", "", plain
	}
};

resource 'MENU' (kEditMenu, preload) {
	kEditMenu,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 8 elements */
		/* [1] */
		"Undo", noIcon, "Z", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "X", "", plain,
		/* [4] */
		"Copy", noIcon, "C", "", plain,
		/* [5] */
		"Paste", noIcon, "V", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain,
		/* [7] */
		"-", noIcon, "", "", plain,
		/* [8] */
		"Select All", noIcon, "A", "", plain,
		/* [9] */
		"-", noIcon, "", "", plain,
		/* [10] */
		"Preferences...", noIcon, "K", "", plain
	}
};

resource 'MENU' (kFontMenu, preload) {
	kFontMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Font",
	{	/* array: 0 elements */
	}
};

resource 'MENU' (kSizeMenu, preload) {
	kSizeMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Size",
	{	/* array: 0 elements */
	}
};

resource 'MENU' (kStyleMenu, preload) {
	kStyleMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Style",
	{	/* array: 8 elements */
		/* [1] */
		"Plain", noIcon, "", "", plain,
		/* [2] */
		"Bold", noIcon, "", "", bold,
		/* [3] */
		"Italic", noIcon, "", "", italic,
		/* [4] */
		"Underline", noIcon, "", "", underline,
		/* [5] */
		"Outline", noIcon, "", "", outline,
		/* [6] */
		"Shadow", noIcon, "", "", shadow,
		/* [7] */
		"Condense", noIcon, "", "", condense,
		/* [8] */
		"Extend", noIcon, "", "", extend
	}
};

resource 'MENU' (kBufferMenu, preload) {
	kBufferMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Config",
	{	/* array: 8 elements */
		/* [1] */
		"28", noIcon, "", "", plain,
		/* [2] */
		"29", noIcon, "", "", plain,
		/* [3] */
		"30", noIcon, "", "", plain,
		/* [4] */
		"31", noIcon, "", "", plain,
		/* [5] */
		"32", noIcon, "", "", plain,
		/* [6] */
		"33", noIcon, "", "", plain,
	}
};

resource 'ALRT' (kShowerrAlert, "Showerr", preload) {
	{130, 84, 211, 428},
	kShowerrAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound2,
		/* [2] */
		OK, visible, sound2,
		/* [3] */
		OK, visible, sound2,
		/* [4] */
		OK, visible, sound2
	}
};

resource 'DITL' (kShowerrAlert, "Showerr", preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{51, 276, 71, 334},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 39, 334},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'actb' (kShowerrAlert) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'alrx' (kShowerrAlert) {
	versionZero
	{
	default_alrx_flags,
	0,
	kUseThemeWindow,
	""
	}
};

resource 'STR#' (kErrorResourceNum) {
	{
		/* [1]: Don't have System 7 or later */
		"System 7.0 or later is required in order to run the this program.",
		/* [2]: PBGetFCBInfo failed */
		"Unable to get file information for this program.",
		/* [3]: MP API missing */
		"Multiprocessing support is not available on this computer.  "
		"You must either install the multiprocessing software "
		"or use the non-multithreaded version of the client.",
		/* [4]: Not using MP API */
		"Two or more processors are installed in this computer. "
		"To make use of more than one, enable Use MP Support in the "
		"Mac OS settings.",
		/* [5]: Memory getting low */
		"Client is almost out of memory. You should close some windows now, "
		"or you might crash.",
		/* [6]: NetInit failed */
		"Unable to initialize networking.  MacTCP or OpenTransport must be "
		"installed.",
		/* [7]: No memory at initialization */
		"Initialization failed: unable to allocated required memory.",
		/* [8]: Configured too many CPUs. */
		"You have selected more CPUs than are installed in this machine.  "
		"All Available is the recommended setting.",
		/* [9]: InstallGNEWatcher failed */
		"Unable to install Gestalt GNE selector.",
		/* [10]: MPCreateCriticalRegion failed */
		"Unable to initialize Multiprocessor API.",
		/* [11]: CPU times incorrect */
		"The Begin after minutes cannot be greater than the "
		"Maximum after minutes.",
		/* [12]: No memory for Help window */
		"Insufficient memory to create the help window.",
		/* [13]: Client initialization failed */
		"Unable to initialize DCTI client code.",
		/* [14]: System too new (for now, 8.5.2 or later) */
		"The client has not been tested with this version of the MacOS. "
		"You may need to disable MP support in order to use the client, "
		"or it may not work reliably at all.  Proceed at your own risk."
	}
};

resource 'STR#' (kFontsList, "Default Fonts") {
	{
		/* [1] */
		"Capitals",
		/* [2] */
		"Charcoal",
		/* [3] */
		"Chicago",
		/* [4] */
		"Courier",
		/* [5] */
		"Gadget",
		/* [6] */
		"Geneva",
		/* [7] */
		"Helvetica",
		/* [8] */
		"Monaco",
		/* [9] */
		"New York",
		/* [10] */
		"Palatino",
		/* [11] */
		"Sand",
		/* [12] */
		"Techno",
		/* [13] */
		"Textile",
		/* [14] */
		"Times"
	}
};

