// Copyright distributed.net 1997-1999 - All Rights Reserved
// For use in distributed.net projects only.
// Any other distribution or use of this source violates copyright.
//
// $Log: socket_glue.h,v $
// Revision 1.4  1999/01/01 02:45:18  cramer
// Part 1 of 1999 Copyright updates...
//
// Revision 1.3  1998/12/24 05:16:00  dicamillo
// Add support for ioctl and for specifying the connection timeout.
//
// Revision 1.2  1998/12/15 07:02:38  dicamillo
// Use "_" instead of "/" in Mac header file names for CVS.
//
// Revision 1.1  1998/12/15 05:58:21  dicamillo
// First Checked In.
//

#include <sys_types.h>
#include <unistd.h>
#include <machine_endian.h>
#include <unistd.mac.h>
#include <sys_time.h>
#include <netdb.h>
#include <netinet_in.h>
#include <sys_socket.h>
typedef int SOCKET;
#define FIONBIO		0x5421

Boolean myNetInit(void);
char * inet_ntoa(struct in_addr inaddr);
struct in_addr inet_addr(char *address);
int gethostname(char *name, int namelen);
long socket_read(int sockfd, void *buf, unsigned long count);
long socket_write(int sockfd, const void *buf, unsigned long count);
int socket_close(int sock);
int socket_ioctl(int sock, unsigned long request, char *arg);
int socket_set_conn_timeout(int sock, int iotimeout);
int shutdown(int sock, int how);
void usleep(unsigned int usec);
Boolean valid_socket(int socket);
